'*** Zuerst ein paar Compiler-Befehle speziell fr PowerBASIC.

'$compile exe ".\telegram.exe"
$cpu 80386
$float npx
$lib all off
$error all off
defint a-z

'*** Diese Parameter steuern verschiedene Teile des Programmes.

MagazinTitel$="TELEGRAM TEXT"
MagazinTitelFarbe=14
HilfeSeite=110
shared SeitenGesperrtBis
if tally(ucase$(command$),"ADMIN")=0 then
  SeitenGesperrtBis=199
else
  SeitenGesperrtBis=99
end if

'*** Die Daten der INI-Datei auswerten

shared Pfad$
if len(dir$("telegram.ini")) then
  open "telegram.ini" for input as #1
  while not eof(1)
    line input #1,z$
    z$=ltrim$(rtrim$(lcase$(z$),any chr$(32,9)),any chr$(32,9))
    if left$(z$,5)="pfad=" then
      Pfad$=mid$(z$,6)
      if len(Pfad$) and right$(Pfad$,1)<>"\" then Pfad$=Pfad$+"\"
      if len(dir$(Pfad$+"tg100.dat"))=0 then Pfad$=""
    elseif left$(z$,8)="browser=" then
      Browser$=mid$(z$,9)
    end if
  wend
  close
end if

'*** Eventuell eine Hilfe anzeigen

if instr(command$,"?") then
  ?"TELETEXT System, programmiert von mad/os, thiemo.maettig@gmx.de
  ?"Letzte Aktualisierung am 24. Mai 2000...
  ?"Die Seiten 100 bis";SeitenGesperrtBis;"sind gesperrt..."
  if len(Pfad$) then
    ?"Ein externes Verzeichnis wird benutzt: ";Pfad$
  else
    ?"Das aktuelle Verzeichnis wird benutzt..."
  end if
  if len(Browser$) then
    ?"Ein externes Programm wurde erkannt: ";Browser$
  else
    ?"Es wurde kein externes Programm definiert..."
  end if
  i$=input$(1)
end if

'*** Lschen des Bildschirmes und Schreiben der wichtigsten Bildelemente

screen 0: width 80: color 15,0: cls
call Blinken (0)					'blinkende Farbe aus
locate 2,5: print "P";
Datum$=mid$(date$,4,2)+". "
select case left$(date$,2)
  case "01": Datum$=Datum$+"Januar"
  case "02": Datum$=Datum$+"Februar"
  case "03": Datum$=Datum$+"Mrz"
  case "04": Datum$=Datum$+"April"
  case "05": Datum$=Datum$+"Mai"
  case "06": Datum$=Datum$+"Juni"
  case "07": Datum$=Datum$+"Juli"
  case "08": Datum$=Datum$+"August"
  case "09": Datum$=Datum$+"September"
  case "10": Datum$=Datum$+"Oktober"
  case "11": Datum$=Datum$+"November"
  case "12": Datum$=Datum$+"Dezember"
end select
locate 2,65-len(Datum$): print Datum$;" ";right$(date$,4);
color 1+16,4: locate 1, 5: print "        >>         ";
color 1+16,2: locate 1,24: print "         <<        ";
color 1+16,6: locate 1,43: print "     F1: Hilfe     ";
color 1+16,1: locate 1,62: print "     Esc: Ende     ";
color MagazinTitelFarbe,0: locate 2,16: print MagazinTitel$;

def seg=&HB800						'sehr wichtig!!!

'*** Einige Variablen werden initialisiert und auf Standardwerte gesetzt.

randomize timer
shared Seite: Seite=100

'*** Beginn der Hauptschleife, die nur mit ESC beendet werden kann.

do
  color 15,0: locate 2,6
  print ltrim$(str$(Seite)); Seite;			'Seitenzahl anzeigen

  if SeiteAlt<>Seite and SeiteVorhanden then
    call LadeSeite: SeiteAlt=Seite
  end if

  while len(inkey$): wend: i$=""			'Puffer leeren
  while i$=""						'wartet auf Taste
    i$=inkey$
    if TimeAlt$<>time$ then
      color 15,0: locate 2,73: print time$;		'zeigt die Zeit an
      TimeAlt$=time$
    end if
  wend

  if FalscheSeite then					'Fehlermeldung weg
    color MagazinTitelFarbe,0: locate 2,16
    print MagazinTitel$;space$(22-len(MagazinTitel$));
    FalscheSeite=0
  end if

  select case i$
    case chr$(13),chr$(0,71): Seite=100			'Enter, Pos1
    case chr$(0,59): Seite=HilfeSeite			'F1: Hilfe
    case "1" to "9"					'1, 2, 3, ... 8, 9
      color 15,0: locate 2,6: print i$;"--";
      Such$=i$: i$=input$(1)
      if i$<"0" or i$>"9" then exit select
      Such$=Such$+i$: locate 2,7: print i$;
      i$=input$(1)
      if i$<"0" or i$>"9" then exit select
      print i$;: color 10,0
      s=Seite: Seite=val(Such$+i$)
      for i=100 to Seite
        if rnd*(i-100)\3=0 then
          locate 2,9: print i;: delay 0.054
        end if
      next
      if SeiteVorhanden=0 then
        FalscheSeite=1: Seite=s: color 12,0
        locate 2,16: print "Seite nicht vorhanden!";
      end if
    case chr$(27),chr$(0,68),chr$(0,45)			'Esc, F10, Alt+X
      exit loop
    case chr$(0,77),chr$(0,80),chr$(0,81)		'Pfeile und Bild ->
      color 10,0: s=Seite
      for i=s-99 to s+800
        Seite=i mod 900+100
        if SeiteVorhanden then exit for
        if rnd*(i-s+100)\5=0 then
	  locate 2,9: print Seite;: delay 0.054
        end if
      next
    case chr$(0,75),chr$(0,72),chr$(0,73)		'Pfeile und Bild <-
      color 10,0: s=Seite
      for i=s+799 to s-100 step -1
        Seite=i mod 900+100
        if SeiteVorhanden then exit for
        if rnd*(799-i+s)\5=0 then
	  locate 2,9: print Seite;: delay 0.054
        end if
      next
    case chr$(0,62)					'F4: Editor
      Temp$=peek$(0,4000): call BearbeiteSeite
      poke$ 0,Temp$: SeiteAlt=0
    case chr$(0,67)					'F9: Browser
      if len(Browser$) then
	Temp$=peek$(0,4000): def seg
	color 14,0: locate 2,16: ?"Externes Programm wird gestartet..."
	shell Browser$
	def seg=&HB800: poke$ 0,Temp$
      end if
  end select
loop

'*** Telegram wurde jetzt beendet.

call Blinken (1)					'Blinken wieder ein
def seg: color 7,0: cls: print Magazintitel$
print "Ende...": end

'----------------------------------------------------------------------------

'*** Hier folgen einige Unterprogramme, die bei Bedarf aufgerufen werden.
'*** Das erste ist auch gleich das wichtigste: Der Editor!

sub BearbeiteSeite
  static Einfuegen, Linienset				'Einfgemodus
  static z,s,v,h					'Position, Farben
  if z=0 then z=3: s=1: v=15

  color 1+16,4: locate 1,6: print "Strg+Pfeil: Farbe";
  color 1+16,2: locate 1,27: print "Alt+C: Lschen";
  color 1+16,6: locate 1,46: print "F2: Speichern";
  color 1+16,1: locate 1,66: print "Esc: Abbruch";
  color 15,0: locate 2,52: print "              modus   Farbe  ";
  call ZeigeFarbe (v,h): locate 2,55
  if Einfuegen then
    print "    Einfge";: locate ,,1,10,15
  else
    print "berschreib";: locate ,,1,0,15
  end if
  poke$ 4000, repeat$(2000,chr$(32,15))

  do
    locate z,s
    i$="": while i$="": i$=inkey$: wend			'wartet auf Taste

    select case i$
      case chr$(27),chr$(0,68): exit loop		'Esc, F10
      case chr$(0,60)					'F2
	if SpeichereSeite=0 then exit loop
      case chr$(0,72): if z=3 then z=25 else decr z	'Pfeil hoch
      case chr$(0,80): if z=25 then z=3 else incr z	'Pfeil runter
      case chr$(0,75): if s=1 then s=80 else decr s	'Pfeil links
      case chr$(0,77): if s=80 then s=1 else incr s	'Pfeil rechts
      case chr$(0,71): s=1				'Pos1
      case chr$(0,79)					'Ende
        s=ZeilenLaenge(z)+1: if s<2 or s>80 then s=80
      case chr$(0,73), chr$(0,132): z=3			'Bild hoch
      case chr$(0,81), chr$(0,118): z=25		'Bild runter
      case chr$(0,119): z=3: s=1			'Strg+Pos1
      case chr$(0,117): z=25: s=80			'Strg+Ende

      case chr$(0,115)					'Strg+Pfeil links
	h=(h+15) mod 16: call ZeigeFarbe (v,h)
      case chr$(0,116)					'Strg+Pfeil rechts
	h=(h+1) mod 16: call ZeigeFarbe (v,h)
      case chr$(0,141)					'Strg+Pfeil hoch
	v=(v+1) mod 16: call ZeigeFarbe (v,h)
      case chr$(0,145)					'Strg+Pfeil runter
	v=(v+15) mod 16: call ZeigeFarbe (v,h)
      case chr$(0,22)					'Alt+U
	v=peek(z*160+s*2-161) mod 16
	h=peek(z*160+s*2-161)\16
	call ZeigeFarbe (v,h)
      case chr$(0,155)					'Alt+Pfeil links
        poke z*160+s*2-161, v+h*16
        if s>1 then decr s
      case chr$(0,157)					'Alt+Pfeil rechts
        poke z*160+s*2-161, v+h*16
        if s<80 then incr s
      case chr$(0,152)					'Alt+Pfeil hoch
        poke z*160+s*2-161, v+h*16
        if z>3 then decr z
      case chr$(0,160)					'Alt+Pfeil runter
        poke z*160+s*2-161, v+h*16
        if z<25 then incr z

      case chr$(9)					'Tabulator
        if s>72 then s=1 else s=((s-1)\8)*8+9
      case chr$(0,15)					'Shift+Tabulator
        if s<9 then s=73 else s=((s-2)\8)*8+1
      case chr$(0,82)					'Einfg
        Einfuegen=1-Einfuegen
        locate 2,55: color 15,0
        if Einfuegen then
	  print "    Einfge";: locate ,,1,10,15
	else
	  print "berschreib";: locate ,,1,0,15
	end if
      case chr$(0,83)					'Entf
	if z<25 and s>ZeilenLaenge(z) and Einfuegen then
	  poke$ z*160+s*2-162, peek$(z*160,162-s*2)
          if ZeilenLaenge(z+1)>81-s then
	    poke$ z*160, peek$(z*160+162-s*2,s*2-2)+repeat$(81-s,chr$(32,15))
          else
            for i=z to 48: poke$ i*160, peek$(i*160+160,160): next
	    poke$ 49*160, repeat$(80,chr$(32,15))
          end if
	else
	  poke$ z*160+s*2-162, peek$(z*160+s*2-160,160-s*2)+chr$(32,15)
	end if
      case chr$(8)					'Backspace
        if s>1 then
	  poke$ z*160+s*2-164, peek$(z*160+s*2-162,162-s*2)+chr$(32,15)
          decr s
        elseif z>3 and Einfuegen then
          s=ZeilenLaenge(z-1)
	  poke$ z*160+s*2-320, peek$(z*160-160,160-s*2)
          if ZeilenLaenge(z)>80-s then
	    poke$ z*160-160, peek$(z*160-s*2,s*2)+repeat$(80-s,chr$(32,15))
          else
            for i=z to 49: poke$ i*160-160, peek$(i*160,160): next
	    poke$ 49*160, repeat$(80,chr$(32,15))
          end if
          decr z: incr s
        end if
      case chr$(13)					'Enter
        if z<25 and Einfuegen then
          for i=49 to z+1 step -1
            poke$ i*160, peek$(i*160-160,160)
          next
          poke$ z*160, peek$(z*160+s*2-162,162-s*2)+repeat$(s-1,chr$(32,15))
          poke$ z*160+s*2-162, repeat$(81-s,chr$(32,15))
        end if
        if z<25 then incr z: s=1
      case chr$(0,46)					'Alt+C
        poke$ 320, repeat$(3840,chr$(32,v+h*16))
      case chr$(0,21),chr$(127)				'Alt+Y, Strg+Backspace
	for i=z to 49
          poke$ i*160-160, peek$(i*160,160)
        next: poke$ 49*160, repeat$(80,chr$(32,15))
      case chr$(0,23)					'Alt+I
	for i=49 to z step -1
          poke$ i*160, peek$(i*160-160,160)
        next: poke$ z*160-160, repeat$(80,chr$(32,v+h*16))
      case chr$(1) to chr$(254)				'alle anderen Tasten
	if Einfuegen then
	  poke$ z*160+s*2-160, peek$(z*160+s*2-162,160-s*2)
	end if

	if Linienset and (i$>="0" and i$<="9" or i$=",") then
	  select case ascii(i$)+Linienset*100
	    case 144: l=179
	    case 148: l=196
	    case 149: l=192
	    case 150: l=193
	    case 151: l=217
	    case 152: l=195
	    case 153: l=197
	    case 154: l=180
	    case 155: l=218
	    case 156: l=194
	    case 157: l=191
	    case 244: l=186
	    case 248: l=205
	    case 249: l=200
	    case 250: l=202
	    case 251: l=188
	    case 252: l=204
	    case 253: l=206
	    case 254: l=185
	    case 255: l=201
	    case 256: l=203
	    case 257: l=187
          end select
	  poke z*160+s*2-162,l
        else
	  poke z*160+s*2-162, ascii(i$)			'Zeichen setzen
        end if
        poke z*160+s*2-161, v+h*16			'Farbe setzen
	if s<80 then incr s

      case chr$(0,63)					'F5
        Linienset=(Linienset+1) mod 3
        locate 2,16: color 11,1
	if Linienset=2 then
	  ?" Linienmodus doppelt  ";
	elseif Linienset=1 then
	  ?" Linienmodus einfach  ";
	else
	  color 8,0: ?" Linienmodus aus        ";
	end if
    end select
  loop
  locate ,,0
end sub

'----------------------------------------------------------------------------

function SpeichereSeite					'Datei speichern
  Temp$=peek$(190,110): color 11,0
  locate 2,16,1,0,15: print "Unter welcher Seitennummer speichern:                  ";

  do
    locate 2,54: print "---";: locate ,54: print s$;
    i$=input$(1)
    select case i$
      case "0" to "9"					'0, 1, 2, ... 8, 9
	if val(left$(s$+i$+"99",3))>SeitenGesperrtBis then
	  s$=s$+i$
          if len(s$)=3 then
	    locate 2,56: print i$;
            Seite=val(s$)
	    if SeiteVorhanden then
	      locate 2,16: print "Die Seite ";s$;" existiert bereits! berschreiben? <j/N>";
              if ucase$(input$(1))="J" then
		exit loop
              else
		s$="": locate 2,16
                print "Unter welcher Seitennummer speichern:                ";
              end if
            else
              exit loop
	    end if
          end if
        end if
      case chr$(8), chr$(0,75)				'Backspace, Pfeil
        if len(s$)>0 then
	  s$=left$(s$,len(s$)-1)
	end if
      case chr$(27)					'Esc
        poke$ 190,Temp$: SpeichereSeite=1: exit function
    end select
  loop

  Dateiname$=Pfad$+"TG"+ltrim$(str$(Seite))
  if len(dir$(Dateiname$+".*"))>0 then kill Dateiname$+".*"
  open Dateiname$+".DAT" for binary as #1
  for z=25 to 3 step -1					'letzte Zeile suchen
    if ZeilenLaenge(z) then LetzteZeile=z: exit for
  next
  for z=3 to LetzteZeile				'Ascii-Text speichern
    for s=1 to ZeilenLaenge(z)
      put$ #1,chr$(peek(z*160+s*2-162))
    next: put$ #1,chr$(13,10)
  next

  for x=1999 to 159 step -1
    if (peek(x*2)<>32 and peek(x*2+1)<>15) _
    or peek(x*2+1)>15 then LetzteFarbe=x: exit for
  next

  if LetzteFarbe>159 then
    put$ #1,chr$(26)+"FARBE"				'Beginn der Farbinfos
    AltesX=160: AlteFarbe=peek(321)
    for x=161 to LetzteFarbe
      if AlteFarbe\16<>peek(x*2+1)\16 _			'anderer Hintergrund
      or (AlteFarbe mod 16<>peek(x*2+1) mod 16 _	'oder Vordergrund
      and peek(x*2)<>32) _				'     ... und Zeichen
      or x-AltesX>253 then				'oder es ist zu lang
        put$ #1,chr$(x-AltesX,AlteFarbe)
        AltesX=x: AlteFarbe=peek(x*2+1)
      end if
    next
    put$ #1,chr$(x-AltesX,AlteFarbe)
  end if
  put$ #1,"": close
end function

'----------------------------------------------------------------------------

sub LadeSeite						'eine Seite anzeigen
  Dateiname$=Pfad$+"TG"+ltrim$(str$(Seite))
  if len(dir$(Dateiname$+".TXT"))>0 then
    Dateiname$=Dateiname$+".TXT"
  elseif len(dir$(Dateiname$+".ANS"))>0 then
    Dateiname$=Dateiname$+".ANS"
  else
    Dateiname$=Dateiname$+".DAT"
  end if
  open Dateiname$ for binary as #1
  get$ #1,10000,x$: close
  poke$ 320, repeat$(1840,chr$(32,15)): color 15,0	'ganzes Bild lschen

  if tally(left$(x$,instr(x$+chr$(26),chr$(26))-1),chr$(27))>1 then
    AnsV=7: AnsZ=2
    do
      if ascii(x$)=27 then
        x$=mid$(x$,3)
        select case ascii(ltrim$(x$, any "0123456789;"))
          case 109					'ESC[Psm = Farben
            do
              select case val(x$)
	        case 0: AnsV=7: AnsH=0: AnsF=0: AnsB=0
	        case 1: AnsF=8
	        case 5: AnsB=128
	        case 30: AnsV=0
	        case 31: AnsV=4
	        case 32: AnsV=2
	        case 33: AnsV=6
	        case 34: AnsV=1
	        case 35: AnsV=5
	        case 36: AnsV=3
	        case 37: AnsV=7
	        case 40: AnsH=0
	        case 41: AnsH=4
	        case 42: AnsH=2
	        case 43: AnsH=6
	        case 44: AnsH=1
	        case 45: AnsH=5
	        case 46: AnsH=3
	        case 47: AnsH=7
              end select
              x$=mid$(x$,instr(x$, any ";m"))
              if ascii(x$)=109 then exit loop
              x$=mid$(x$,2)
            loop: x$=mid$(x$,2)
          case 65					'ESC[PnA = nach oben
            decr AnsZ,max%(val(x$),1)
            if AnsZ<2 then AnsZ=2
            x$=mid$(x$,instr(x$,"A")+1)
          case 67					'ESC[PnC = rechts
            incr AnsS,val(x$): if AnsS>79 then AnsS=79
            x$=mid$(x$,instr(x$,"C")+1)
          case else
            x$=mid$(ltrim$(x$,any"0123456789;"),2)
        end select
      elseif ascii(x$)=13 then
        incr AnsZ: AnsS=0: x$=mid$(x$,3)
      elseif ascii(x$)=26 then				'Dateiende
	exit loop
      else
        poke AnsZ*160+AnsS*2, ascii(x$)
        poke AnsZ*160+AnsS*2+1, AnsV+AnsH*16+AnsF+AnsB
        incr AnsS: x$=mid$(x$,2)
        if AnsS>79 then AnsS=0: incr AnsZ
        if AnsZ>24 then exit loop
      end if
    loop while len(x$)

  else							'DAT oder Text
    for z=3 to 25
      p=instr(x$,any chr$(13,26)): if p=0 then p=len(x$)+1
      locate z,1: print left$(x$,min%(p-1,80));
      x$=mid$(x$,p+2)
      if len(x$)=0 or ascii(x$)=26 then exit for
    next
    if ascii(x$)=26 then
      p=321
      for i=7 to len(x$) step 2
        l=ascii(mid$(x$,i)): Farbe=ascii(mid$(x$,i+1))
        for s=0 to l-1: poke p+s*2, Farbe: next
        incr p,l*2: if p>3999 then exit sub
      next
    end if
  end if

end sub

'----------------------------------------------------------------------------

function SeiteVorhanden
  if len(dir$(Pfad$+"TG"+ltrim$(str$(Seite))+".*")) then SeiteVorhanden=1
end function

function ZeilenLaenge (z)
  for i=158 to 0 step -2
    if peek(z*160+i-160)<>32 then ZeilenLaenge=i\2+1: exit function
  next: ZeilenLaenge=0
end function

sub ZeigeFarbe (v,h)
  for i=303 to 319 step 2: poke i,v+h*16: next
end sub

SUB Blinken (Status)
  REG 1, &H1003: REG 2, Status: CALL INTERRUPT &H10
END SUB